## Dynamic Loading of Modules

Dynamic Loading of Modules — portable method for dynamically loading 'plug-ins'

## Functions

gboolean | g_module_supported ()
gchar * | g_module_build_path ()
GModule * | g_module_open ()
gboolean | g_module_symbol ()
const gchar * | g_module_name ()
void | g_module_make_resident ()
gboolean | g_module_close ()
const gchar * | g_module_error ()
const gchar * | ( *GModuleCheckInit ) ()
void | ( *GModuleUnload ) ()

## Types and Values

| GModule
enum | GModuleFlags
#define | G_MODULE_SUFFIX
#define | G_MODULE_EXPORT
#define | G_MODULE_IMPORT

## Includes

    #include <gmodule.h>

## Description

These functions provide a portable way to dynamically load object files (commonly known as 'plug-ins'). The current implementation supports all systems that provide an implementation of `dlopen()` (e.g. Linux/Sun), as well as Windows platforms via DLLs.

A program which wants to use these functions must be linked to the libraries output by the command `pkg-config --libs gmodule-2.0`.

To use them you must first determine whether dynamic loading is supported on the platform by calling `g_module_supported()`. If it is, you can open a module with `g_module_open()`, find the module's symbols (e.g. function names) with `g_module_symbol()`, and later close the module with `g_module_close()`. `g_module_name()` will return the file name of a currently opened module.

If any of the above functions fail, the error status can be found with `g_module_error()`.

The GModule implementation features reference counting for opened modules, and supports hook functions within a module which are called when the module is loaded and unloaded (see GModuleCheckInit and GModuleUnload).

If your module introduces static data to common subsystems in the running program, e.g. through calling `g_quark_from_static_string ("my-module-stuff")`, it must ensure that it is never unloaded, by calling `g_module_make_resident()`.

Example: Calling a function defined in a GModule

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42

    // the function signature for 'say_hello'
    typedef void (* SayHelloFunc) (const char *message);

    gboolean
    just_say_hello (const char *filename, GError **error)
    {
      SayHelloFunc  say_hello;
      GModule      *module;

      module = g_module_open (filename, G_MODULE_BIND_LAZY);
      if (!module)
        {
          g_set_error (error, FOO_ERROR, FOO_ERROR_BLAH,
                       "%s", g_module_error ());
          return FALSE;
        }

      if (!g_module_symbol (module, "say_hello", (gpointer *)&say_hello))
        {
          g_set_error (error, SAY_ERROR, SAY_ERROR_OPEN,
                       "%s: %s", filename, g_module_error ());
          if (!g_module_close (module))
            g_warning ("%s: %s", filename, g_module_error ());
          return FALSE;
        }

      if (say_hello == NULL)
        {
          g_set_error (error, SAY_ERROR, SAY_ERROR_OPEN,
                       "symbol say_hello is NULL");
          if (!g_module_close (module))
            g_warning ("%s: %s", filename, g_module_error ());
          return FALSE;
        }

      // call our function in the module
      say_hello ("Hello world!");

      if (!g_module_close (module))
        g_warning ("%s: %s", filename, g_module_error ());
      return TRUE;
     }

## Functions

### g_module_supported ()

    gboolean
    g_module_supported (void);

Checks if modules are supported on the current platform.

#### Returns

`TRUE` if modules are supported

### g_module_build_path ()

    gchar *
    g_module_build_path (const gchar *directory,
                         const gchar *module_name);

A portable way to build the filename of a module. The platform-specific prefix and suffix are added to the filename, if needed, and the result is added to the directory, using the correct separator character.

The directory should specify the directory where the module can be found. It can be `NULL` or an empty string to indicate that the module is in a standard platform-specific directory, though this is not recommended since the wrong module may be found.

For example, calling `g_module_build_path()` on a Linux system with a `directory` of `/lib` and a `module_name` of "mylibrary" will return `/lib/libmylibrary.so`. On a Windows system, using `\Windows` as the directory it will return `\Windows\mylibrary.dll`.

#### Parameters

directory | the directory where the module is. This can be `NULL` or the empty string to indicate that the standard platform-specific directories will be used, though that is not recommended. | [nullable]
module_name | the name of the module |

#### Returns

the complete path of the module, including the standard library prefix and suffix. This should be freed when no longer needed

### g_module_open ()

    GModule *
    g_module_open (const gchar *file_name,
                   GModuleFlags flags);

Opens a module. If the module has already been opened, its reference count is incremented.

First of all `g_module_open()` tries to open `file_name` as a module. If that fails and `file_name` has the ".la"-suffix (and is a libtool archive) it tries to open the corresponding module. If that fails and it doesn't have the proper module suffix for the platform (G_MODULE_SUFFIX), this suffix will be appended and the corresponding module will be opended. If that fails and `file_name` doesn't have the ".la"-suffix, this suffix is appended and `g_module_open()` tries to open the corresponding module. If eventually that fails as well, `NULL` is returned.

#### Parameters

file_name | the name of the file containing the module, or `NULL` to obtain a GModule representing the main program itself. | [nullable]
flags | the flags used for opening the module. This can be the logical OR of any of the GModuleFlags |

#### Returns

a GModule on success, or `NULL` on failure

### g_module_symbol ()

    gboolean
    g_module_symbol (GModule *module,
                     const gchar *symbol_name,
                     gpointer *symbol);

Gets a symbol pointer from a module, such as one exported by G_MODULE_EXPORT. Note that a valid symbol can be `NULL`.

#### Parameters

module | a GModule |
symbol_name | the name of the symbol to find |
symbol | returns the pointer to the symbol value. | [out]

#### Returns

`TRUE` on success

### g_module_name ()

    const gchar *
    g_module_name (GModule *module);

Returns the filename that the module was opened with.

If `module` refers to the application itself, "main" is returned.

#### Parameters

module | a GModule |

#### Returns

the filename of the module.

[transfer none]

### g_module_make_resident ()

    void
    g_module_make_resident (GModule *module);

Ensures that a module will never be unloaded. Any future `g_module_close()` calls on the module will be ignored.

#### Parameters

module | a GModule to make permanently resident |

### g_module_close ()

    gboolean
    g_module_close (GModule *module);

Closes a module.

#### Parameters

module | a GModule to close |

#### Returns

`TRUE` on success

### g_module_error ()

    const gchar *
    g_module_error (void);

Gets a string describing the last module error.

#### Returns

a string describing the last module error

### GModuleCheckInit ()

    const gchar *
    (*GModuleCheckInit) (GModule *module);

Specifies the type of the module initialization function. If a module contains a function named `g_module_check_init()` it is called automatically when the module is loaded. It is passed the GModule structure and should return `NULL` on success or a string describing the initialization error.

#### Parameters

module | the GModule corresponding to the module which has just been loaded |

#### Returns

`NULL` on success, or a string describing the initialization error

### GModuleUnload ()

    void
    (*GModuleUnload) (GModule *module);

Specifies the type of the module function called when it is unloaded. If a module contains a function named `g_module_unload()` it is called automatically when the module is unloaded. It is passed the GModule structure.

#### Parameters

module | the GModule about to be unloaded |

## Types and Values

### GModule

    typedef struct _GModule GModule;

The GModule struct is an opaque data structure to represent a dynamically-loaded module. It should only be accessed via the following functions.

### enum GModuleFlags

Flags passed to `g_module_open()`. Note that these flags are not supported on all platforms.

#### Members

G_MODULE_BIND_LAZY | specifies that symbols are only resolved when needed. The default action is to bind all symbols when the module is loaded. |
G_MODULE_BIND_LOCAL | specifies that symbols in the module should not be added to the global name space. The default action on most platforms is to place symbols in the module in the global name space, which may cause conflicts with existing symbols. |
G_MODULE_BIND_MASK | mask for all flags. |

### G_MODULE_SUFFIX

    #define G_MODULE_SUFFIX "so"

Expands to the proper shared library suffix for the current platform without the leading dot. For most Unices and Linux this is "so", and for Windows this is "dll".

### G_MODULE_EXPORT

    #  define G_MODULE_EXPORT		__declspec(dllexport)

Used to declare functions exported by libraries or modules.

When compiling for Windows, it marks the symbol as `dllexport`.

When compiling for Linux and Unices, it marks the symbol as having `default` visibility. This is no-op unless the code is being compiled with a non-default visibility flag such as `hidden`.

### G_MODULE_IMPORT

    #define G_MODULE_IMPORT		extern

Used to declare functions imported from modules.